package schedframe.resources.computing.profiles.load.ui;

import java.util.List;

import org.joda.time.DateTimeUtils;

import schedframe.resources.computing.profiles.energy.MeasurementHistory;
import schedframe.resources.computing.profiles.load.LoadProfile;
import schedframe.resources.computing.profiles.load.ResourceLoadCalendar;
import schedframe.resources.devices.PhysicalResource;

public class ComputingResourceLoadInterface implements LoadInterface{

	protected PhysicalResource resource;
	protected LoadProfile loadProfile;
	
	public ComputingResourceLoadInterface(PhysicalResource resource, LoadProfile loadProfile){
		this.resource = resource;
		this.loadProfile = loadProfile;
	}

	public MeasurementHistory getRecentUtilization() {
		MeasurementHistory load = null;
		int lastIdx = getUtilizationHistory().size() - 1;
		if(lastIdx >= 0)
			load = getUtilizationHistory().get(lastIdx);
		else {	
			load = new MeasurementHistory(DateTimeUtils.currentTimeMillis(), 0);
		}
		return load;
	}
	
	public List<MeasurementHistory> getUtilizationHistory(){
		return loadProfile.getUtilizationHistory();
	}

	public ResourceLoadCalendar getLoadCalendar() {
		if(loadProfile == null) {
			return new ResourceLoadCalendar();
		}
		return loadProfile.getLoadCalendar();
	}
}
